// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*! 
 * @file Pose.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _GEOMETRY_MSGS_POSE_HPP_
#define _GEOMETRY_MSGS_POSE_HPP_


#include "../topic.hpp"


#include "../geometry_msgs/Point.hpp"
#include "../geometry_msgs/Quaternion.hpp"

namespace geometry_msgs {

class Pose : public ros2::Topic<Pose>
{
public:
  geometry_msgs::Point position;
  geometry_msgs::Quaternion orientation;

  Pose():
    Topic("geometry_msgs::msg::dds_::Pose_", "Pose", GEOMETRY_MSGS_POSE_ID),
    position(),
    orientation()
  { 
  }


  bool serialize(void* msg_buf, const Pose* topic)
  {
    ucdrBuffer* writer = (ucdrBuffer*)msg_buf;
    (void) position.serialize(writer, &topic->position);
    (void) orientation.serialize(writer, &topic->orientation);

    return !writer->error;
  }

  bool deserialize(void* msg_buf, Pose* topic)
  {
    ucdrBuffer* reader = (ucdrBuffer*)msg_buf;
    (void) position.deserialize(reader, &topic->position);
    (void) orientation.deserialize(reader, &topic->orientation);

    return !reader->error;
  }

  uint32_t size_of_topic(const Pose* topic, uint32_t size)
  {
    uint32_t previousSize = size;
    size += position.size_of_topic(&topic->position, size);
    size += orientation.size_of_topic(&topic->orientation, size);
    
    return size - previousSize;
  }

};

} // namespace geometry_msgs


#endif // _GEOMETRY_MSGS_POSE_HPP_
